package com.ruoyi.ehsMaterial.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.ruoyi.common.utils.SecurityUtils;
import org.springframework.stereotype.Service;
import org.springframework.beans.factory.annotation.Autowired;
import com.ruoyi.common.utils.StringUtils;
import java.util.List;
import java.util.Map;
import com.ruoyi.ehsMaterial.mapper.EhsMaterialMapper;
import com.ruoyi.ehsMaterial.domain.EhsMaterial;
import com.ruoyi.ehsMaterial.service.IEhsMaterialService;

/**
 * 物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”Service业务层处理
 *
 * @author ruoyi
 * @date 2023-12-04
 */
@Service
public class EhsMaterialServiceImpl extends ServiceImpl<EhsMaterialMapper, EhsMaterial> implements IEhsMaterialService {

    @Autowired
    private EhsMaterialMapper ehsMaterialMapper;

    /**
     * 查询物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”
     *
     * @param materialId 物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”主键
     * @return 物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”
     */
    @Override
    public EhsMaterial selectEhsMaterialByMaterialId(Long materialId)
    {
        return ehsMaterialMapper.selectEhsMaterialByMaterialId(materialId);
    }

    /**
     * 查询物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”列表
     *
     * @param ehsMaterial 物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”
     * @return 物资信息包含  通用应急救援装备”“防汛抗旱应急救援装备”“森林防灭火应急救援装备”“救灾物资”
     */
    @Override
    public List<EhsMaterial> selectEhsMaterialList(EhsMaterial ehsMaterial)
    {
        if(SecurityUtils.getLoginUser().getUser().getDept().getParentId()!=null &&
                SecurityUtils.getLoginUser().getUser().getDept().getParentId().longValue()!=0){
            ehsMaterial.setDeptId(SecurityUtils.getLoginUser().getUser().getDept().getDeptId().longValue());
        }
        return ehsMaterialMapper.selectEhsMaterialList(ehsMaterial);
    }


    private LambdaQueryWrapper<EhsMaterial> buildQueryWrapper(EhsMaterial query) {
        Map<String, Object> params = query.getParams();
        LambdaQueryWrapper<EhsMaterial> lqw = Wrappers.lambdaQuery();
        lqw.eq(query.getMaterialType() != null, EhsMaterial::getMaterialType, query.getMaterialType());
        lqw.eq(query.getClassFirst() != null, EhsMaterial::getClassFirst, query.getClassFirst());
        lqw.eq(StringUtils.isNotBlank(query.getClassSecond()), EhsMaterial::getClassSecond, query.getClassSecond());
        lqw.like(StringUtils.isNotBlank(query.getMaterialName()), EhsMaterial::getMaterialName, query.getMaterialName());
        lqw.eq(StringUtils.isNotBlank(query.getMaterialSpecs()), EhsMaterial::getMaterialSpecs, query.getMaterialSpecs());
        lqw.eq(StringUtils.isNotBlank(query.getMaterialQuantity()), EhsMaterial::getMaterialQuantity, query.getMaterialQuantity());
        lqw.like(StringUtils.isNotBlank(query.getReserveLocation()), EhsMaterial::getReserveLocation, query.getReserveLocation());
        lqw.like(StringUtils.isNotBlank(query.getManagerPerson()), EhsMaterial::getManagerPerson, query.getManagerPerson());
        lqw.like(StringUtils.isNotBlank(query.getTel()), EhsMaterial::getTel, query.getTel());
        lqw.orderByDesc(EhsMaterial::getCreateTime);
        return lqw;
    }

}
